<?php
/*##### rrinnermodmenu1_cssjs.php - a "protected" Include file installed by Robin Richmond's mods
that define an "Inner Mod Menus" in a TNG program.
The Inner Mod Menu is a right-floated drop-down menu in the standard TNG Inner Menu.
It contains links that provide information about Robin's mods that update the program.

This file contains css and script blocks. The css and script blocks are not defiened
as external .css and .js files because more than one mod can affect one program,
it is is a lot easier to make sure that an Include is included only once
than to make sure that .css and .js files are attached to a program only once.
*/
?>
<script>
/////////////////////////////////////////////
//document.ready function for programs that have an Inner Mod Menu.
//Each mod that added InnerModMenu links created a div with class='rrinnermodmenu'.
//All of those divs will be merged into a new drop-down menu with id='rInnerModMenu'.
///////////////////////////////////////////
$(function () {
	var rrModMenuOccurrences = $('.rrInnerModMenu').length;
	if (!rrModMenuOccurrences) return; //***************Early exit - no menus

	//Build the consolidated InnerModMenu contents from the InnerModMenus of each mod. 
	var rrModMenuHTML = '';
	$('.rrInnerModMenu').each (function() {
		rrModMenuHTML += $(this).html();
		$(this).remove();
	})

	//Add the InnerModMenu wrapper to the Inner menu.
	var rrInnerMenuID;
	if ($('#adm_innermenu')) rrInnerMenuID = '#adm-innermenu';
	else rrInnerMenuID = '#pub-innermenu';
	var html = "<div id='rrInnerModMenu'>";
	html += "<a href='#' class='lightlink' onclick='return false;'>Mod Information</a>";
	html += "<div id='rrInnerModDrop' class='slidedown'>";
	html += "<a href='#' class='rrInnerModMenuX'><img src='{$cms['tngpath']}img/tng_close.gif' border='0' alt=''></a>";
	html += "</div></div>";
	$(rrInnerMenuID).append(html);

	//Add the InnerModMenu contents to the wrapper
	$('#rrInnerModDrop').append(rrModMenuHTML);

	//Define the height of the InnerModMenu, based on the count of lines (<br> tags) in the content.
	var rrNumLines = rrModMenuHTML.split('<br>').length;
	$('#rrInnerModDrop').css('height',(rrNumLines*1.4)+'em');

	//Toggle the InnerModMenu when the menu label in the Inner Menu is clicked.
	$('#rrInnerModMenu').click(function () {
		$('#rrInnerModDrop').slideToggle(200);
		return false;
	});
	//Close the InnerModMenu when its X is clicked
	$('#rrInnerModDrop>a').click(function () {
		$('#rrInnerModDrop').slideUp(200);
	});
}); //end document.ready function

//////////////////////////////////////////////////
//function rrInnerMenuOpenWikiPage opens a TNG Wiki page as a popup.
//It is invoked by on-click events in links inside an Inner Mod Menu.
function rrInnerModOpenWikiPage(article, anchor='') {
	if (anchor) anchor="#"+anchor;
	newwindow = window.open('https://tng.lythgoes.net/wiki/index.php?title='+article+anchor, 'wikiwindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrInnerMenuOpenWikiPage

//////////////////////////////////////////////////
//Open a TNG Admin>>Setup page as a popup.
function rrInnerModOpenConfigPage(configprogram, subform='', modid='') {
	if (configprogram.indexOf('.php') == -1)
		configprogram += '.php';
	if (!subform) {
		if (configprogram == 'admin_genconfig.php') subform = 'robin';
		else if (configprogram == 'admin_pedconfig.php') subform = 'peddesc';
	}
	newwindow = window.open(configprogram+"?open="+subform+'&mod='+modid, 'optionswindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrInnerModOpenConfigPage

</script>

<style>
/*********** Styles for Inner Mod Menus *******************/
#rrInnerModMenu {float:right; padding-right:8px; position:relative;}
.rrInnerModMenuX {padding-left:15px; float:right}
#rrInnerModDrop {z-index:200; color:orange;
	position:absolute; top:20px; left:-168px;
	padding:2px 4px;
	width:240px; height:4em; margin-right:15px;
	border-radius:5px;
	line-height:1.4em;
	display:none;
}
#rrInnerModDrop>a {text-decoration:none;}
#rrInnerModDrop>a:hover {text-decoration:underline;}
.rrInnerModWiki {cursor:pointer;
	width:16px; height:16px;
}
.rrInnerModNotLink{color:black;} /*XYZZY makes sure the background color is correct */
</style>
