<?php
/*##### rrsetup_modoptions1_cssjs.php - a "protected" Include file installed by Robin Richmond's mods

This file contains css and script blocks. The css and script blocks are not defiened
as external .css and .js files because more than one mod can affect one program,
it is is a lot easier to make sure that an Include is included only once
than to make sure that .css and .js files are attached to a program only once.
There is not a companion PHP-code file for this JS/CSS file, as there is
for the InnerModMenu.

Each mod that places option form fields in an Admin>>Setup program defines
them in a HTML table with class=rrConfigTable. That table just a holding
place for the options fields. A document.ready function copies the contents
of all of those HTML tables into the appropriate HTML layout table in the 
program's HTML form.

The tables with class=rrConfigTable also must have the custom HTML attribute
"modname, which (duh) contains the mod name. It may also have two optional
HTML attributes:
- "subform" identifies a subform within the Admin>>Setup program, and
- "group" specifys a mod group ('Places', 'Media', 'People, etc).
  Right now, the group name is placed after the mod name at the top of
  the mod's block of options. I intend to build a table of contents
  that will list the mods grouped by the group name.
*/
?>
<script>
/////////////////////////////////////////////
//document.ready function for Admin>>Setup programs to which Robin's mods have added options.
//This code can be invoked from admin_genconfig.php, admin_pedconfig,php, etc.

//The document.ready function performs three distinct tasks:
//1. In admin_genconfig.php, create a new subform labeled "Robin's Mods"
//   Mod options that are placed in other subforms in admin_genconfig.php must
//   hard-code the positioning of those options fields.
//2. Sort the HTML tables by modname.
//3. Move the contents of each HTML table into the specified subform in the program.

$(function() {
	//Nothing to do if there are no options tables.
	if (!$('.rrConfigTable')) return false; 

	var configProgram = window.location.pathname.split("/").pop();
	if (configProgram == 'admin_genconfig.php') {
		//Create a new subform named robin (in a div in a table row) for new options.
		var html = "<tr class='databack tngshadow'><td class='tngshadow>";
		html += "<span class='subhead'><a href='#' onclick=\"return toggleSection('robin','plus14');\" class='togglehead' style='color:black'>";
		html += "<img src='img/tng_expand.gif' title='toggle display' alt='toggle display' width='15' height='15' border='0' id='plus14'>";
		html += "<strong class='th-indent'>Robin's Mods</strong></a></span><br />";
		html += "<div id='robin' style='display:none'><br><table><tbody></tbody></table></div>";
		html += "</td></tr>";
		$("#misc").closest('tr').after(html);
	}

	//Sort (by group and mod name) the options tables that mods have created
	var rrGroups = Array();
	var rrMods = Array();
	var rrModOptions = Array();
	$('.rrConfigTable').each(function() {
		var group = $(this).attr('group');
		if (!group) group = 'Miscellaneous';
		var modname = $(this).attr('modname');
		var rr = rrGroups.indexOf(group);
		if (rr < 0) {
			rrGroups.push(group);
			rrMods[group] = Array();
		}
		rrMods[group].push(modname);
		rrModOptions[modname] = $(this);
	});
	rrGroups.sort();
	for (rr=0; rr<rrGroups.length; rr++)
		rrMods[rrGroups[rr]].sort();

	//Move each table into the appropriate form or subform
	for (rr1=0; rr1<rrGroups.length; rr1++) {
		group = rrGroups[rr1];
		for (rr2=0; rr2<rrMods[group].length; rr2++) {
			var modname = rrMods[group][rr2];
			var modid = modname.replace(/ /g, '');
			rrModOptions[modname].children('tbody').addClass('rrconfig-tbody normal');

			var subform = rrModOptions[modname].attr('subform');
			if (typeof(subform) == "undefined") {
				if (configProgram == 'admin_genconfig.php') subform = 'robin';
				else if (configProgram == 'admin_pedconfig.php') subform = 'peddesc';
				else subform = '';
			}
			var parentElement = (subform) ? $('#'+subform) : $('form');
			if (subform)
				parentElement = $('#'+subform);
			else parentElement = $('form');
			html = "<tr><td colspan='5' class='normal'>" +
				"<div style='float:right;'><input type='submit' name='submit' value='Submit All'></div>" +
				"<div class='rrConfig-wrap' tabindex='-1' id='" +modid+ "'>" +
				"<b style='font-size:110%;'>"+modname+"</b> ("+group+") &nbsp;" +
				"<img src='rrmodadmin_wikilogo.png" class='nw rrModAdminWiki'" +
					"onclick=\\\"rrModOptionsOpenWikiPage('"+$modname + "');\\\"" +
					" onclick=\"return rrModOptionsOpenWikiPage('" +modname+ "', 'Mod_Options');\">" +
					"<table>" + rrModOptions[modname].html() + "</table></div></td></tr>";
			parentElement.children('table').first().children('tbody').first().append(html);
			$(this).remove();
		}
	}

	//Open the subform section specified by the querystring parameter 'open'.
	var section = rrGetQueryStringParam('open');
	if (section)
		toggleSection(section, rrGetImageId(section), 'on');

	//Open the mod specified by the querystring parameter 'mod'.
	var mod = rrGetQueryStringParam('mod');
	if (section)
		toggleSection(section, rrGetImageId(section), 'on');

	//Bring focus to the mod's options.
	if (mod) $('#'+mod).focus();
}); //end document.ready function

////////////////////////////////////////////////
//Structural function called by the document.ready function.
function rrGetQueryStringParam(sParam) {
	var sPageURL = window.location.search.substring(1);
	var sURLVariables = sPageURL.split('&');
	for (var i = 0; i < sURLVariables.length; i++) {
		var sParameterName = sURLVariables[i].split('=');
		if (sParameterName[0] == sParam)
			return sParameterName[1];
	}
	return '';
} //end function rrGetQueryStringParam

///////////////////////////////////////////////
//Structural function called by the admin_*config document.ready function.
//When the querystring has an "open" parameter, determine the image ID
//associated with that section.
function rrGetImageId (formSection) {
	switch (formSection) {
		case 'ped': return 'plus0';
		case 'desc': return 'plus1';
		case 'rel': return 'plus2';
		case 'time': return 'plus3';
		case 'peddesc': return 'plus4';
		case 'db': return 'plus0';
		case 'tables': return 'plus1';
		case 'folders': return 'plus2';
		case 'site': return 'plus3';
		case 'media': return 'plus4';
		case 'lang': return 'plus5';
		case 'priv': return 'plus6';
		case 'names': return 'plus7';
		case 'cemeteries': return 'plus8';
		case 'mailreg': return 'plus9';
		case 'pref': return 'plus10';
		case 'mobile': return 'plus11';
		case 'dna': return 'plus12';
		case 'misc': return 'plus13';
	} //end switch
} //end function buildSectionMap

//////////////////////////////////////////////////
//function rrModOptionsOpenWikiPage opens a TNG Wiki page as a popup.
//It is invoked by Wikipedia icon next the mod name that serves as a heading
//for that mod's options.
function rrModOptionsOpenWikiPage(article, anchor='') {
	newwindow = window.open('https://tng.lythgoes.net/wiki/index.php?title='+article+'#'+anchor, 'wikiwindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrModOptionsOpenWikiPage
</script>

<style>
/************* Styles and function for Mod Options **************/
/* The dummy table that contains the options form field definitions before they
are moved into the programs form. */
.rrConfigTable {display:none;}
/* Div that wraps the mod's heading and the HTML table that contains the form fields. */
.rrConfig-wrap {box-shadow: 0 0 0 2px grey; border-radius:5px;
	padding:1px 3px;}
.rrConfig-wrap>h4 {margin:0;}
/* The wrapper is initially hidden, and is displayed only after it is fully populated by the
options that are copied from a dummy table with class=rrConfigTable.
/* In the Admin>>Setup program's HTML layout table, each mod's options are defined in a tbody element */
.rrconfig-tbody {border-spacing:0;
	vertical-align:top;}
.rrconfig-tbody input[type='checkbox'] {position:relative; top:2px;}
.rrconfig-tbody input[type='radio'] {position:relative; top:2px;}
.rrconfig-tbody>tr>td:first-child {text-align:right;
	padding-right:4px; padding-top:4px;}
</style>
