<?php
/*##### rrsetup_modoptions1_cssjs.php - a "protected" Include file installed by Robin Richmond's mods

This file contains css and script blocks. The css and script blocks are not defiened
as external .css and .js files because more than one mod can affect one program,
it is is a lot easier to make sure that an Include is included only once
than to make sure that .css and .js files are attached to a program only once.
There is not a companion PHP-code file for this JS/CSS file, as there is
for the InnerModMenu.

Each mod that places option form fields in an Admin>>Setup program defines
them in a HTML table with class=rrConfigTable. That table just a holding
place for the options fields. A document.ready function copies the contents
of all of those HTML tables into the appropriate HTML layout table in the 
program's HTML form.

The tables with class=rrConfigTable also must have the custom HTML attribute
"modname, which (duh) contains the mod name. It may also have two optional
HTML attributes:
- "subform" identifies a subform within the Admin>>Setup program, and
- "group" specifys a mod group ('Places', 'Media', 'People, etc).
  Right now, the group name is placed after the mod name at the top of
  the mod's block of options. I intend to build a table of contents
  that will list the mods grouped by the group name.
*/
?>
<script>
/////////////////////////////////////////////
//document.ready function for Admin>>Setup programs to which Robin's mods have added options.
//This code can be invoked from admin_genconfig.php, admin_pedconfig,php, etc.

//The document.ready function performs three distinct tasks:
//1. In admin_genconfig.php, create a new subform labeled "Robin's Mods"
//   Mod options that are placed in other subforms in admin_genconfig.php must
//   hard-code the positioning of those options fields.
//2. Sort the HTML tables by modname.
//3. Move the contents of each HTML table into the specified subform in the program.
$(function() {
	//Nothing to do if there are no options tables.
	if (!$('.rrConfigTable').length) return false; 

	var configProgram = window.location.pathname.split("/").pop();
	if (configProgram == 'admin_genconfig.php') {
		//Create a new subform for all of Robin's mods. It is like all of the other subforms.
		//Give it the label "Robin's Mods" and id="robin".
		var html = "<tr class='databack tngshadow'><td class='tngshadow>";
		html += "<span class='subhead'><a href='#' onclick='return rrToggleRobin();' class='togglehead' style='color:black'>";
		html += "<img src='img/tng_expand.gif' title='toggle display' alt='toggle display' width='15' height='15' border='0' id='plusrr'>";
		html += "<strong class='th-indent'>Robin's Mods" +"</strong></a></span><br />";
		html += "<div id='robin' style='display:none'><br><table class='normal'><tbody></tbody></table></div>";
		html += "</td></tr>";
		//The new subform follows the last native subform, 'Miscellaneous'
		$("#misc").closest('tr').after(html);
	}

	//Sort the options tables that Robin's mods have created.
	var rrGroups = Array();
	var rrMods = Array();
	var rrModOptions = Array();
	var rrModSubform = Array();
	var rrCount = 0; //Counts mod that go in Robin's new subforkm
	$('.rrConfigTable').each(function() {
		var modname = $(this).attr('modname');
		rrMods.push(modname);
		rrModOptions[modname] = $(this);
		var subform = $(this).attr('subform');
		if (typeof(subform) == "undefined") {
			if (configProgram == 'admin_genconfig.php') {
				subform = 'robin';
				rrCount++;
			}
			else if (configProgram == 'admin_pedconfig.php')
				subform = 'peddesc';
			else subform = '';
		}
		rrModSubform[modname] = subform;
		$(this).remove();
	});
	rrMods.sort(); //Sort by modname

	//Hide each mod if a modid has been passed to this program
	//and there are enough mods to make hiding them worthwhile.
	var modToOpen = rrGetQueryStringParam('mod');
	var modDisplayStyle = '';
	if (modToOpen && rrCount>4) 
		modDisplayStyle = " style='display:none;'";

var xyz=0;
	//Put each mod into the appropriate subform
	for (rr=0; rr<rrMods.length; rr++) {
		var modname = rrMods[rr];
		var modid = modname.replace(/ /g, '');
		var group = rrModOptions[modname].attr('group');
		if (!group) group = 'Misc'; //Not used for now

		html = "<tr"+modDisplayStyle+" tabindex='-1' id='" +modid+ "' class='rrModOptions'>" +
			"<td colspan='5' class='normal'>" +
			"<div style='float:right;'><input type='submit' name='submit' value='Save All'></div>" +
			"<div class='rrModWrapper'>" +
			"<b style='font-size:110%;'>"+modname+"</b> &nbsp;" +
			"<img src='img/rrmodadmin_wikilogo.png' style='height:16px;width:16px;' class='nw rrModAdminWiki'" +
				"onclick=\"return rrModOptionsOpenWikiPage('" +modname+ "', 'Mod_Options');\">" +
			"<table class='rrModTable normal'>" + rrModOptions[modname].html() + "</table>" +
			"</div></td></tr>";

		//Each mod's content is put a new table row at the end of the form's layout table,
		//or, if there is a subform, in the subform's layout table.
		//(The calls to the .first method is probably be unnecessary, but doesn't hurt.)
		var parentElement = $('form');
		if (rrModSubform[modname])
			parentElement = $('#'+rrModSubform[modname]);
		parentElement.children('table').first().children('tbody').first().append(html);
	}

	//Open the subform section specified by the querystring parameter 'open',
	var subform = rrGetQueryStringParam('open');
	if (subform) {
		if (subform=='robin') {
			if (modToOpen) {
				$("#"+modToOpen).show(); //Don't toggle the arrow in the heading
				//Open the mod and bring focus to it.
				$("#robin").show();
				$('#'+modToOpen).focus();
			} else { //Open the subform and all mods in it
				rrToggleRobin();
			}
		} else { //Use the generic function to open the subform
			toggleSection(subform, rrGetImageId(subform), 'on');
		}
	} //end if open a subform
}); //end document.ready function

////////////////////////////////////////////////
//Function to toggle the display of the subform for Robin's mods.
//It is different from the generic toggleSection function because each
//mod in the subform must be opened the first time the subform is opened.
function rrToggleRobin() {
	if ($('#plusrr').attr('src')=='img/tng_expand.gif') {
//	if ($('#robin').css('display')=='block') {
		//Opening the subform. Each mod must be opened, too.
		$('#robin').show();
		$('#plusrr').attr('src', 'img/tng_collapse.gif');
		$('.rrModOptions').show(); //Show each mod
	} else { //Closing the subform 	
		//There is no need to hide each mod
		$('#robin').hide();
		$('#plusrr').attr('src', 'img/tng_expand.gif');
	}
	return false;
} //end function rrToggleRobin

////////////////////////////////////////////////
//Structural function called by the document.ready function.
function rrGetQueryStringParam(sParam) {
	var sPageURL = window.location.search.substring(1);
	var sURLVariables = sPageURL.split('&');
	for (var i = 0; i < sURLVariables.length; i++) {
		var sParameterName = sURLVariables[i].split('=');
		if (sParameterName[0] == sParam)
			return sParameterName[1];
	}
	return '';
} //end function rrGetQueryStringParam

///////////////////////////////////////////////
//Structural function called by the admin_*config document.ready function.
//When the querystring has an "open" parameter, determine the image ID
//associated with that section.
function rrGetImageId (formSection) {
	switch (formSection) {
		case 'ped': return 'plus0';
		case 'desc': return 'plus1';
		case 'rel': return 'plus2';
		case 'time': return 'plus3';
		case 'peddesc': return 'plus4';
		case 'db': return 'plus0';
		case 'tables': return 'plus1';
		case 'folders': return 'plus2';
		case 'site': return 'plus3';
		case 'media': return 'plus4';
		case 'lang': return 'plus5';
		case 'priv': return 'plus6';
		case 'names': return 'plus7';
		case 'cemeteries': return 'plus8';
		case 'mailreg': return 'plus9';
		case 'pref': return 'plus10';
		case 'mobile': return 'plus11';
		case 'dna': return 'plus12';
		case 'misc': return 'plus13';
	} //end switch
} //end function buildSectionMap

//////////////////////////////////////////////////
//function rrModOptionsOpenWikiPage opens a TNG Wiki page as a popup.
//It is invoked by Wikipedia icon next the mod name that serves as a heading
//for that mod's options.
function rrModOptionsOpenWikiPage(article, anchor='') {
	newwindow = window.open('https://tng.lythgoes.net/wiki/index.php?title='+article+'#'+anchor, 'wikiwindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrModOptionsOpenWikiPage
</script>

<style>
/************* Styles for Robin's Mod Options **************/
/* The dummy table that contains the options form field definitions before they
are moved into the programs form. */
.rrConfigTable {display:none;}
/* rrModWrap wraps each mod's content */
.rrModWrapper {box-shadow: 0 0 0 2px grey;
	border-radius:5px;
	padding:1px 3px;}
.rrModWrapper h4 {margin:0;}
.rrModWrapper tr {vertical-align:top;}
.rrModWrapper input[type='checkbox'] {position:relative; top:2px;}
.rrModWrapper input[type='radio'] {position:relative; top:2px;}
.rrModTable {clear:both;}
/* Right justify the option field prompts, but not first elements in each row
 of a subordinate table. */
.rrModTable>tbody>tr>td:first-child {text-align:right;
	padding-right:4px; padding-top:4px;}
</style>
